<?php
/**
 *
 * Copyright © 2016 Magento. All rights reserved.
 * See COPYING.txt for license details.
 */

namespace FiloBlu\OrderAdditionalData\Model\Plugin;

/*
 * Add Order Increment ID to Shipment
 */
class ShipmentSave
{

    /** 
     * @var \Magento\Sales\Api\OrderRepositoryInterface 
     */
    protected $orderRepository;


    /**
     * ShipmentSave constructor.
     * @param \Magento\Framework\App\Helper\Context $context
     * @param \Magento\Sales\Api\OrderRepositoryInterface $orderRepository
     */
    public function __construct(
        \Magento\Framework\App\Helper\Context $context,    
        \Magento\Sales\Api\OrderRepositoryInterface $orderRepository
    ) {
        $this->orderRepository=$orderRepository;
    }

    /**
     * @param \Magento\Sales\Api\ShipmentRepositoryInterface $subject
     * @param \Magento\Sales\Api\Data\ShipmentInterface $shipment
     * @return array
     */
    public function beforeSave(
        \Magento\Sales\Api\ShipmentRepositoryInterface $subject,
        \Magento\Sales\Api\Data\ShipmentInterface $shipment
    ) {
        $order_increment_id=$shipment->getData("order_increment_id");
        if ($order_increment_id==null) {
            $order=$this->orderRepository->get($shipment->getOrderId());
            $shipment->setData("order_increment_id", $order->getIncrementId());
        }
        return array($shipment);
    }
}
