<?php
/**
 * Copyright © 2016 Filoblu S.r.l. All rights reserved.
 */
namespace FiloBlu\OrderAdditionalData\Observer;
use \Magento\Framework\Event\Observer;
use \Magento\Framework\Event\ObserverInterface;

/**
 * Observer on Order Status Update
 */
 
 class ShipmentSave implements ObserverInterface{
	
    /** 
     * @var \Magento\Sales\Api\OrderRepositoryInterface 
     */
    protected $orderRepository;

     /**
      * ShipmentSave constructor.
      * @param \Magento\Sales\Api\OrderRepositoryInterface $orderRepository
      */
	public function __construct(
            \Magento\Sales\Api\OrderRepositoryInterface $orderRepository
	){
            $this->orderRepository=$orderRepository;
	}

    /**
     * Save Order Increment ID in Shipment Object
     *
     * @param \Magento\Framework\Event\Observer $observer
     * @return \Magento\Sales\Api\Data\ShipmentInterface 
     */
    public function execute(Observer $observer){    
        $shipment = $observer->getEvent()->getShipment();
        $order_increment_id=$shipment->getData("order_increment_id");
        if ($order_increment_id==null) {
            $order=$this->orderRepository->get($shipment->getOrderId());
            $shipment->setData("order_increment_id", $order->getIncrementId());
        }
        return $shipment;
    }
}